Index: src/perl/register-dataset.cgi
===================================================================
--- src/perl/register-dataset.cgi	(revision 5310)
+++ src/perl/register-dataset.cgi	(revision 5311)
@@ -909,390 +1115,428 @@
 #
 ################################################################################
 sub allFileData {
-    my %uploadedFiles = ();
-    my $fileInfo;
-    my $docid;
+	my %uploadedFiles = ();
+	my $fileInfo;
+	my $docid;
 
-    for (my $fileNum = 0; $fileNum <= $FORM::upCount; $fileNum++) {
-        my $fn = 'upload_' . $fileNum;
-        if (hasContent(param($fn))) {
-            # ignore data which is scheduled for deletion
-            if (grep {$_ eq ("uploadname_$fileNum")} @FORM::deletefile) {
-                debug("Not generating metadata for file scheduled for deletion: $fn");
-            } else {
-                debug("Retrieving metadata for file: $fn");
-                ($docid, $fileInfo) = fileMetadata($fileNum);
-                $uploadedFiles{ $docid } = $fileInfo;
-            }
-        }
-    }
+	for ( my $fileNum = 0 ; $fileNum <= $FORM::upCount ; $fileNum++ ) {
+		my $fn = 'upload_' . $fileNum;
+		if ( hasContent( param($fn) ) ) {
 
-    return %uploadedFiles;
+			# ignore data which is scheduled for deletion
+			if ( grep { $_ eq ("uploadname_$fileNum") } @FORM::deletefile ) {
+				debug(
+"Not generating metadata for file scheduled for deletion: $fn"
+				);
+			}
+			else {
+				debug("Retrieving metadata for file: $fn");
+				( $docid, $fileInfo ) = fileMetadata($fileNum);
+				$uploadedFiles{$docid} = $fileInfo;
+			}
+		}
+	}
+
+	return %uploadedFiles;
 }
 
 sub fileMetadata {
-    my $fileNum = shift;
-    my $fileHash = param("upload_$fileNum");
-    my $fileName = param("uploadname_$fileNum");
-    my $contentType = param("uploadtype_$fileNum");
-    my $filePerm = param("uploadperm_$fileNum");
-    my $docid;
-    my $outFile;
-    my $cleanName = $fileName;
+	my $fileNum     = shift;
+	my $fileHash    = param("upload_$fileNum");
+	my $fileName    = param("uploadname_$fileNum");
+	my $contentType = param("uploadtype_$fileNum");
+	my $filePerm    = param("uploadperm_$fileNum");
+	my $docid;
+	my $outFile;
+	my $cleanName = $fileName;
 
-    # process an _existing_ data file, which is already within Metacat.
-    if ($fileHash =~ /ondisk/) {
-        ($docid, $fileHash) = datafileInfo($fileHash);
-        $outFile = $dataDir . "/" . $docid;
-    } else {
-        # normalize input filenames; Windows filenames include full paths
-        $cleanName =~ s/.*[\/\\](.*)/$1/;
-        $outFile = $tempDir . "/" . $cleanName;
-    } 
-    debug("Reading file from disk: $outFile");
+	# process an _existing_ data file, which is already within Metacat.
+	if ( $fileHash =~ /ondisk/ ) {
+		( $docid, $fileHash ) = datafileInfo($fileHash);
+		$outFile = $dataDir . "/" . $docid;
+	}
+	else {
 
-    my $fileSize = stat($outFile)->size;
-    if ($fileSize == 0) {
-        push(@errorMessages, "file $fileName is zero bytes!");
-        debug("File $fileName is zero bytes!");
-    }
+		# normalize input filenames; Windows filenames include full paths
+		$cleanName =~ s/.*[\/\\](.*)/$1/;
+		$outFile = $tempDir . "/" . $cleanName;
+	}
+	debug("Reading file from disk: $outFile");
 
-    # Now the file is on disk, send the object to Metacat
-    my $session = CGI::Session->load();
-    if ($session->is_empty) {
-        push(@errorMessages, "Must be logged in to upload files.");
-        debug("Not logged in, cannot upload files.");
-        return 0;
-    }
+	my $fileSize = stat($outFile)->size;
+	if ( $fileSize == 0 ) {
+		push( @errorMessages, "file $fileName is zero bytes!" );
+		debug("File $fileName is zero bytes!");
+	}
 
-    if (!$docid) {
-        $docid = newAccessionNumber($config->{'scope'}, $metacat);
-        my $uploadReturn = uploadData($outFile, $docid);
-        if (!$uploadReturn) {
-            debug("Uploading the data failed.");
-        }
-    }
-    my $entityid = $fileHash."001";
-    my $distribid = $fileHash."002";
+	# Now the file is on disk, send the object to Metacat
+	my $session = CGI::Session->load();
+	if ( $session->is_empty ) {
+		push( @errorMessages, "Must be logged in to upload files." );
+		debug("Not logged in, cannot upload files.");
+		return 0;
+	}
 
-    my $uploadUrl = 'ecogrid://knb/' . $docid;
-    # TODO:  should match the object promotion path, so that an
-    #        Excel upload results in 'dataTable' in this field
-    my $entityType = 'Other';
+	if ( !$docid ) {
+		$docid = newAccessionNumber( $config->{'scope'}, $metacat );
+		my $uploadReturn = uploadData( $outFile, $docid );
+		if ( !$uploadReturn ) {
+			debug("Uploading the data failed.");
+		}
+	}
+	my $entityid  = $fileHash . "001";
+	my $distribid = $fileHash . "002";
 
-    my %dataInfo = (  'docid'       => $docid,
-                      'entityid'    => $entityid,
-                      'distribid'   => $distribid,
-                      'fileName'    => $cleanName,
-                      'fileSize'    => $fileSize,
-                      'fileHash'    => $fileHash,
-                      'filePerm'    => $filePerm,
-                      'contentType' => $contentType,
-                      'url'         => $uploadUrl,
-                      'entityType'  => $entityType,
-                   );
+	my $uploadUrl = 'ecogrid://knb/' . $docid;
 
-    return ($docid, \%dataInfo);
+	# TODO:  should match the object promotion path, so that an
+	#        Excel upload results in 'dataTable' in this field
+	my $entityType = 'Other';
+
+	my %dataInfo = (
+		'docid'       => $docid,
+		'entityid'    => $entityid,
+		'distribid'   => $distribid,
+		'fileName'    => $cleanName,
+		'fileSize'    => $fileSize,
+		'fileHash'    => $fileHash,
+		'filePerm'    => $filePerm,
+		'contentType' => $contentType,
+		'url'         => $uploadUrl,
+		'entityType'  => $entityType,
+	);
+
+	return ( $docid, \%dataInfo );
 }
 
 sub datafileInfo {
-    my $finfo = shift;
-    $finfo =~ s/ondisk://g;
-    return my ($docid, $fileHash) = split (":", $finfo);
+	my $finfo = shift;
+	$finfo =~ s/ondisk://g;
+	return my ( $docid, $fileHash ) = split( ":", $finfo );
 }
 
 sub processFile {
-    my $fileName = shift;
+	my $fileName = shift;
 
-    # test that we actually got a file
-    if(!$fileName || cgi_error()) {
-        debug("Error receiving file ". cgi_error());
-    }
-   
-    # write file to disk, get SHA1 hash and size
-    my ($outFile, $fileHash) = writeFile($fileName);
+	# test that we actually got a file
+	if ( !$fileName || cgi_error() ) {
+		debug( "Error receiving file " . cgi_error() );
+	}
 
-    my $fileSize = stat($outFile)->size;
-    if ($fileSize == 0) {
-        push(@errorMessages, "file $fileName is zero bytes!");
-        debug("File $fileName is zero bytes!");
-    }
+	# write file to disk, get SHA1 hash and size
+	my ( $outFile, $fileHash ) = writeFile($fileName);
 
-    # file is in Metacat, generate the pertinent EML elements
-    my $contentType = uploadInfo($fileName)->{'Content-Type'};
-    # occasionally CGI.pm doesn't get the file info.  In this case,
-    # use a default MIME type of text/plain.  Seems fixed in the newer CGI.pm:
-    # http://bugs.debian.org/cgi-bin/bugreport.cgi?bug=313141
-    if (!$contentType) {
-        $contentType = 'text/plain';
-    }
+	my $fileSize = stat($outFile)->size;
+	if ( $fileSize == 0 ) {
+		push( @errorMessages, "file $fileName is zero bytes!" );
+		debug("File $fileName is zero bytes!");
+	}
 
-    my %dataInfo = ( 'fileName'    => $fileName,
-                     'fileHash'    => $fileHash,
-                     'contentType' => $contentType,
-                   );
+	# file is in Metacat, generate the pertinent EML elements
+	my $contentType = uploadInfo($fileName)->{'Content-Type'};
 
-    return \%dataInfo;
+	# occasionally CGI.pm doesn't get the file info.  In this case,
+	# use a default MIME type of text/plain.  Seems fixed in the newer CGI.pm:
+	# http://bugs.debian.org/cgi-bin/bugreport.cgi?bug=313141
+	if ( !$contentType ) {
+		$contentType = 'text/plain';
+	}
+
+	my %dataInfo = (
+		'fileName'    => $fileName,
+		'fileHash'    => $fileHash,
+		'contentType' => $contentType,
+	);
+
+	return \%dataInfo;
 }
 
 sub writeFile {
-    my $fileName = shift;
-    my $fileData;
-    my $length = 0;
-    my $buffer;
+	my $fileName = shift;
+	my $fileData;
+	my $length = 0;
+	my $buffer;
 
-    my $cleanName = $fileName;
+	my $cleanName = $fileName;
 
-    # normalize input filenames; Windows filenames include full paths
-    $cleanName =~ s/.*[\/\\](.*)/$1/;
+	# normalize input filenames; Windows filenames include full paths
+	$cleanName =~ s/.*[\/\\](.*)/$1/;
 
-    while (my $bytesRead = read($fileName, $buffer, 4096)) {
-        $fileData .= $buffer;
-        $length += $bytesRead;
-    }
+	while ( my $bytesRead = read( $fileName, $buffer, 4096 ) ) {
+		$fileData .= $buffer;
+		$length += $bytesRead;
+	}
 
-    # create SHA1 sum to store file hash
-    my $ctx = Digest::SHA1->new;
-    $ctx->add($fileData);
-    my $digest = $ctx->hexdigest;
+	# create SHA1 sum to store file hash
+	my $ctx = Digest::SHA1->new;
+	$ctx->add($fileData);
+	my $digest = $ctx->hexdigest;
 
-    my $outputName = $tempDir . "/" . $cleanName;
-    open(OUT,">$outputName") or die "Could not open: $!";
-    print OUT $fileData;
-    close(OUT);
-    debug("Writing output, result is: $outputName");
+	my $outputName = $tempDir . "/" . $cleanName;
+	open( OUT, ">$outputName" ) or die "Could not open: $!";
+	print OUT $fileData;
+	close(OUT);
+	debug("Writing output, result is: $outputName");
 
-    return ($outputName, $digest);
+	return ( $outputName, $digest );
 }
 
 sub deleteRemovedData {
-    # if we have any associated datafiles which are scheduled for deletion, remove them now
-    for (my $delNum = 0; $delNum <= $FORM::delCount; $delNum++) {
-        # need to look up the actual upload number, which is contained in the name
-        my $upNum = param("deletefile_$delNum");
-        $upNum =~ s/uploadname_//;
-        my $upn = param("upload_$upNum");
-        if (hasContent($upn)) {
-            debug("Deleting upload_$upNum, $upn");
-            if (grep {$_ eq ("uploadname_$upNum")} @FORM::deletefile) {
-                if (param("upload_$upNum") =~ /ondisk/) {
-                    debug("got a file which is ondisk, proceeding with deletion");
-                    deleteFileData(param("upload_$upNum"));
-                } else {
-                    debug("got an old reference, not yet in EML, remove from tempdir");
-                    deleteFile(param("uploadname_$upNum"));
-                }
-            } else {
-                debug("Name didn't match in deletefile list");
-            }
-        }
-    }
+
+# if we have any associated datafiles which are scheduled for deletion, remove them now
+	for ( my $delNum = 0 ; $delNum <= $FORM::delCount ; $delNum++ ) {
+
+	  # need to look up the actual upload number, which is contained in the name
+		my $upNum = param("deletefile_$delNum");
+		$upNum =~ s/uploadname_//;
+		my $upn = param("upload_$upNum");
+		if ( hasContent($upn) ) {
+			debug("Deleting upload_$upNum, $upn");
+			if ( grep { $_ eq ("uploadname_$upNum") } @FORM::deletefile ) {
+				if ( param("upload_$upNum") =~ /ondisk/ ) {
+					debug(
+						"got a file which is ondisk, proceeding with deletion");
+					deleteFileData( param("upload_$upNum") );
+				}
+				else {
+					debug(
+"got an old reference, not yet in EML, remove from tempdir"
+					);
+					deleteFile( param("uploadname_$upNum") );
+				}
+			}
+			else {
+				debug("Name didn't match in deletefile list");
+			}
+		}
+	}
 }
 
 sub deleteFile {
-    my $input = shift;
-    my $fileName = $tempDir . "/" . $input;
+	my $input    = shift;
+	my $fileName = $tempDir . "/" . $input;
 
-    if (-e $fileName) {
-        unlink $fileName or
-            debug("Failed to delete file $fileName.");
-    } else {
-        debug("Unable to find file $fileName");
-    }
-    if (!-e $fileName) {
-        debug("Successfully deleted $fileName");
-    }
+	if ( -e $fileName ) {
+		unlink $fileName
+		  or debug("Failed to delete file $fileName.");
+	}
+	else {
+		debug("Unable to find file $fileName");
+	}
+	if ( !-e $fileName ) {
+		debug("Successfully deleted $fileName");
+	}
 }
 
 sub deleteFileData {
-    my $input = shift;
-    my ($docid, $fileHash) = datafileInfo($input);
-    my $metacat = Metacat->new($metacatUrl);
+	my $input = shift;
+	my ( $docid, $fileHash ) = datafileInfo($input);
+	my $metacat = Metacat->new($metacatUrl);
 
-    my ($username, $password) = getCredentials();
-    my $response = $metacat->login($username, $password);
-    if (!$response) {
-        my $msg = $metacat->getMessage();
-        push(@errorMessages, "Failed to login with credentials for `$username`. Error was $msg");
-        debug("Failed to login with given credentials for username $username, Error is: $msg");
-    } else {
-        $response = $metacat->delete($docid);
-        if (!$response) {
-            my $msg = $metacat->getMessage();
-            push(@errorMessages, "Failed to delete existing file. Error was: $msg");
-            debug("Delete -- Error is: $msg");
-        } else {
-            debug("Delete -- Success! Removed docid $docid");
-        }
-    }
+	my ( $username, $password ) = getCredentials();
+	my $response = $metacat->login( $username, $password );
+	if ( !$response ) {
+		my $msg = $metacat->getMessage();
+		push( @errorMessages,
+			"Failed to login with credentials for `$username`. Error was $msg"
+		);
+		debug(
+"Failed to login with given credentials for username $username, Error is: $msg"
+		);
+	}
+	else {
+		$response = $metacat->delete($docid);
+		if ( !$response ) {
+			my $msg = $metacat->getMessage();
+			push( @errorMessages,
+				"Failed to delete existing file. Error was: $msg" );
+			debug("Delete -- Error is: $msg");
+		}
+		else {
+			debug("Delete -- Success! Removed docid $docid");
+		}
+	}
 }
 
 sub uploadData {
-    my $data = shift;
-    my $docid = shift;
+	my $data  = shift;
+	my $docid = shift;
 
-    debug("Upload -- Starting upload of $docid");
-    my $response = $metacat->upload($docid, $data);
-    if (!$response) {
-        my $uploadMsg = $metacat->getMessage();
-        push(@errorMessages, "Failed to upload file. Error was: $uploadMsg\n");
-        debug("Upload -- Error is: $uploadMsg");
-    } else {
-        debug("Upload -- Success! New docid $docid");
-    }
+	debug("Upload -- Starting upload of $docid");
+	my $response = $metacat->upload( $docid, $data );
+	if ( !$response ) {
+		my $uploadMsg = $metacat->getMessage();
+		push( @errorMessages,
+			"Failed to upload file. Error was: $uploadMsg\n" );
+		debug("Upload -- Error is: $uploadMsg");
+	}
+	else {
+		debug("Upload -- Success! New docid $docid");
+	}
 }
 
-
 ################################################################################
-# 
+#
 # Create the XML document from the HTML form input
 # returns the XML document as a string
 #
 ################################################################################
 sub createXMLDocument {
-    #FIXME placeholder for $FORM element, should be determined by config
 
-    if ($skinName eq "ebm") {
-        return createProjectDocument();
-    } else {
-        return createDatasetDocument();
-    }
+	#FIXME placeholder for $FORM element, should be determined by config
+
+	if ( $skinName eq "ebm" ) {
+		return createProjectDocument();
+	}
+	else {
+		return createDatasetDocument();
+	}
 }
 
 sub createProjectDocument {
-    my $doc = EMLStart();
-    $doc .= accessElement();
-    $doc .= datasetStart();
-    $doc .= titleElement();
-    $doc .= creatorNameElement();
-    $doc .= creatorElement();
+	my $doc = EMLStart();
+	$doc .= accessElement();
+	$doc .= datasetStart();
+	$doc .= titleElement();
+	$doc .= creatorNameElement();
+	$doc .= creatorElement();
 
-    $doc .= pubElement();
-    $doc .= setDisplayType('project');
-    $doc .= keywordElement();
-    $doc .= contactElement();
+	$doc .= pubElement();
+	$doc .= setDisplayType('project');
+	$doc .= keywordElement();
+	$doc .= contactElement();
 
-    # putting everything else under project
-    $doc .= "<project>";
-    $doc .= titleElement();
-    my %originators = personnelCreate('personnel');
-    $doc .= personnelList(\%originators);
-    $doc .= abstractElement();
-    $doc .= "<studyAreaDescription>\n";
-    $doc .= coverageElement();
-    $doc .= "</studyAreaDescription>\n";
+	# putting everything else under project
+	$doc .= "<project>";
+	$doc .= titleElement();
+	my %originators = personnelCreate('personnel');
+	$doc .= personnelList( \%originators );
+	$doc .= abstractElement();
+	$doc .= "<studyAreaDescription>\n";
+	$doc .= coverageElement();
+	$doc .= "</studyAreaDescription>\n";
 
-    $doc .= "</project>";
-    $doc .= datasetEnd();
-    $doc .= EMLEnd();
-    return $doc;
+	$doc .= "</project>";
+	$doc .= datasetEnd();
+	$doc .= EMLEnd();
+	return $doc;
 }
 
 sub createDatasetDocument {
-    my $doc = EMLStart();
-    $doc .= accessElement();
-    $doc .= datasetStart();
-    $doc .= titleElement();
-    $doc .= creatorElement();
-    $doc .= contactElement('creator');
-    my %originators = personnelCreate('associatedParty');
-    $doc .= personnelList(\%originators);
+	my $doc = EMLStart();
+	$doc .= accessElement();
+	$doc .= datasetStart();
+	$doc .= titleElement();
+	$doc .= creatorElement();
+	$doc .= creatorContactElement();
+	my %originators = personnelCreate('associatedParty');
+	$doc .= personnelList( \%originators );
 
-    $doc .= pubElement();
-    $doc .= abstractElement();
-#    $doc .= setDisplayType('dataset');
-    $doc .= keywordElement();
-    $doc .= distributionElement();
-    $doc .= coverageElement();
-    $doc .= contactElement();
-    $doc .= methodsElement();
-    my %fileData = allFileData();
-    $doc .= entityElement(\%fileData);
-    $doc .= datasetEnd();
-    $doc .= EMLEnd();
+	$doc .= pubElement();
+	$doc .= abstractElement();
+
+	#    $doc .= setDisplayType('dataset');
+	$doc .= keywordElement();
+	$doc .= distributionElement();
+	$doc .= coverageElement();
+	$doc .= contactElement();
+	$doc .= methodsElement();
+	my %fileData = allFileData();
+	$doc .= entityElement( \%fileData );
+	$doc .= datasetEnd();
+	$doc .= EMLEnd();
 }
 
 # EML document creation functions
 
 sub personnelCreate {
-    # passed parameter defines default role for individuals
-    my $defaultRole = shift;
-    # element name => objects of that type
-    my %orig = (
-                'creator'          => [],
-                'metadataProvider' => [],
-                'publisher'        => [],
-                $defaultRole       => [],
-            );
-    # form name => EML element name
-    my %roles = (
-                 'Originator'        => 'creator',
-                 'Metadata Provider' => 'metadataProvider',
-                 'Publisher'         => 'publisher',
-              );
 
-    push (@{$orig{'metadataProvider'}}, [$FORM::providerGivenName, $FORM::providerSurName]);
+	# passed parameter defines default role for individuals
+	my $defaultRole = shift;
 
-    # Additional originators
-    foreach my $origName (param()) {
-        my $origNum = $origName;
-        $origNum =~ s/origNamelast//; # get the index of the parameter 0 to 10
-        if ($origNum =~ /^([0-9]+)$/) {
-            # do not generate EML for empty originator fields
-            if (hasContent(param("origNamefirst" . $origNum))) {
-                my $first = normalize(param("origNamefirst" . $origNum));
-                my $last  = normalize(param("origNamelast" . $origNum));
-                my $origRole = param("origRole" . $origNum);
-                my $roleName = $roles{$origRole};
-                if (!hasContent($roleName)) {
-                  $roleName = $defaultRole;
-                }
+	# element name => objects of that type
+	my %orig = (
+		'creator'          => [],
+		'metadataProvider' => [],
+		'publisher'        => [],
+		$defaultRole       => [],
+	);
 
-                push (@{$orig{$roleName}}, [$first, $last, $origRole]);
-            }
-        }
-    }
-    return %orig;
+	# form name => EML element name
+	my %roles = (
+		'Originator'        => 'creator',
+		'Metadata Provider' => 'metadataProvider',
+		'Publisher'         => 'publisher',
+	);
+
+	push(
+		@{ $orig{'metadataProvider'} },
+		[ $FORM::providerGivenName, $FORM::providerSurName ]
+	);
+
+	# Additional originators
+	foreach my $origName ( param() ) {
+		my $origNum = $origName;
+		$origNum =~ s/origNamelast//;   # get the index of the parameter 0 to 10
+		if ( $origNum =~ /^([0-9]+)$/ ) {
+
+			# do not generate EML for empty originator fields
+			if ( hasContent( param( "origNamefirst" . $origNum ) ) ) {
+				my $first    = normalize( param( "origNamefirst" . $origNum ) );
+				my $last     = normalize( param( "origNamelast" . $origNum ) );
+				my $origRole = param( "origRole" . $origNum );
+				my $roleName = $roles{$origRole};
+				if ( !hasContent($roleName) ) {
+					$roleName = $defaultRole;
+				}
+
+				push( @{ $orig{$roleName} }, [ $first, $last, $origRole ] );
+			}
+		}
+	}
+	return %orig;
 }
 
 sub personnelList {
-    my ($orig, $type) = @_;
-    my %orig = %$orig;
-    
-    my $elemList = "";
-    foreach my $role (keys %orig) {
-        foreach my $v (@{$orig->{$role}}) {
-            my ($first, $last, $origRole) = @$v;
-            my $elem = "<individualName>\n";
-            $elem .= "<givenName>".normalize($first)."</givenName>\n";
-            $elem .= "<surName>".normalize($last)."</surName>\n";
-            $elem .= "</individualName>\n";
+	my ( $orig, $type ) = @_;
+	my %orig = %$orig;
 
-            if (($role eq 'personnel') && ($FORM::origNameOrgContact)) {
-                $elem .= "<organizationName>$FORM::origNameOrgContact</organizationName>\n";
-            }
+	my $elemList = "";
+	foreach my $role ( keys %orig ) {
+		foreach my $v ( @{ $orig->{$role} } ) {
+			my ( $first, $last, $origRole ) = @$v;
+			my $elem = "<individualName>\n";
+			$elem .= "<givenName>" . normalize($first) . "</givenName>\n";
+			$elem .= "<surName>" . normalize($last) . "</surName>\n";
+			$elem .= "</individualName>\n";
 
-            if (($role eq 'personnel') || ($role eq 'associatedParty')) {
-                my $roleElem = $role;
-                if (hasContent($origRole)) {
-                    $roleElem = $origRole;
-                }
-                $elem .= "<role>".normalize($roleElem)."</role>\n";
-            }
-            $elemList .= "<$role>$elem</$role>\n";
-        }
-    }
-    return $elemList;
+			if ( ( $role eq 'personnel' ) && ($FORM::origNameOrgContact) ) {
+				$elem .=
+"<organizationName>$FORM::origNameOrgContact</organizationName>\n";
+			}
+
+			if ( ( $role eq 'personnel' ) || ( $role eq 'associatedParty' ) ) {
+				my $roleElem = $role;
+				if ( hasContent($origRole) ) {
+					$roleElem = $origRole;
+				}
+				$elem .= "<role>" . normalize($roleElem) . "</role>\n";
+			}
+			$elemList .= "<$role>$elem</$role>\n";
+		}
+	}
+	return $elemList;
 }
 
 sub entityElement() {
-    my $entityObjects = shift;
-    my %entityObjects = %$entityObjects;
-    my $entityList = "";
+	my $entityObjects = shift;
+	my %entityObjects = %$entityObjects;
+	my $entityList    = "";
 
-    my $access = fileAccessElement(\%entityObjects);
-    while (my ($docid, $data) = each(%entityObjects)) {
-        my $entityStub = qq|<otherEntity id="$data->{'entityid'}" scope="document">
+	my $access = fileAccessElement( \%entityObjects );
+	while ( my ( $docid, $data ) = each(%entityObjects) ) {
+		my $entityStub =
+		  qq|<otherEntity id="$data->{'entityid'}" scope="document">
             <entityName>$data->{'fileName'}</entityName>
             <physical scope="document">
                 <objectName>$data->{'fileName'}</objectName>
@@ -1313,28 +1557,28 @@
             <entityType>$data->{'entityType'}</entityType>
     </otherEntity>
 |;
-    $entityList .= $entityStub;
-    }
+		$entityList .= $entityStub;
+	}
 
-    return $entityList;
+	return $entityList;
 }
 
 sub fileAccessElement() {
-    my $entityObjects = shift;
-    my %entityObjects = %$entityObjects;
-    my $userAccess = allowElement(getUsername(), 'all');
-    my $skinAccess = allowElement($adminUsername, 'all');
-    my $accessList = "";
+	my $entityObjects = shift;
+	my %entityObjects = %$entityObjects;
+	my $userAccess    = allowElement( getUsername(), 'all' );
+	my $skinAccess    = allowElement( $adminUsername, 'all' );
+	my $accessList    = "";
 
-    # form name => EML permission; roles akin to Apache model
-    my %accessRoles = (
-        'public'  => 'allow',
-        'private' => 'deny',
-    );
+	# form name => EML permission; roles akin to Apache model
+	my %accessRoles = (
+		'public'  => 'allow',
+		'private' => 'deny',
+	);
 
-    while (my ($docid, $data) = each(%entityObjects)) {
-        my $defaultAccess = $accessRoles{$data->{'filePerm'}};
-        $accessList = qq|
+	while ( my ( $docid, $data ) = each(%entityObjects) ) {
+		my $defaultAccess = $accessRoles{ $data->{'filePerm'} };
+		$accessList = qq|
                 <access authSystem="knb" order="denyFirst">
                     $skinAccess
                     $userAccess 
@@ -1344,56 +1588,60 @@
                     </$defaultAccess>
                 </access>
     |;
-    }
+	}
 
-  return $accessList;
+	return $accessList;
 }
 
 sub keywordElement() {
-    my %kwSet, my $kwList = (), "";
+	my %kwSet, my $kwList = (), "";
 
-    # process the standard keywords
-    foreach my $kwName (param()) {
-        my $kwNum = $kwName;
-        $kwNum =~ s/keyword//; # get the index of the parameter 0, ..., 10
-        if ($kwNum =~ /^([0-9]+)$/) {
-            # don't generate xml for empty keyword fields
-            # don't generate taxonomic keyword fields, those go in taxonomic coverage
-            if (hasContent(param($kwName))) {
-                my $kwType = param("kwType" . $kwNum);
-                my $kwTh   = param("kwTh" . $kwNum);
-                my $kw     = param("keyword" . $kwNum);
+	# process the standard keywords
+	foreach my $kwName ( param() ) {
+		my $kwNum = $kwName;
+		$kwNum =~ s/keyword//;    # get the index of the parameter 0, ..., 10
+		if ( $kwNum =~ /^([0-9]+)$/ ) {
 
-                push(@{$kwSet{$kwTh}}, [$kw, $kwType]);
-            }
-        }
-    }
+	   # don't generate xml for empty keyword fields
+	   # don't generate taxonomic keyword fields, those go in taxonomic coverage
+			if ( hasContent( param($kwName) ) ) {
+				my $kwType = param( "kwType" . $kwNum );
+				my $kwTh   = param( "kwTh" . $kwNum );
+				my $kw     = param( "keyword" . $kwNum );
 
-    # output keyword lists
-    while ((my $thesaurus, my $a_ref) = each %kwSet) {
-        my $kwElem .= "<keywordSet>\n";
+				push( @{ $kwSet{$kwTh} }, [ $kw, $kwType ] );
+			}
+		}
+	}
 
-        foreach my $x (@$a_ref) {
-            my ($kw, $kwType) = @$x;
-            $kwElem .= "<keyword ";
-            if (hasContent($kwType) && $kwType != "None") {
-                 $kwElem.= "keywordType=\"".lc($kwType)."\"";
-            }
-            $kwElem .= ">$kw</keyword>\n";
-        }
+	# output keyword lists
+	while ( ( my $thesaurus, my $a_ref ) = each %kwSet ) {
+		my $kwElem .= "<keywordSet>\n";
 
-        $kwElem .= "<keywordThesaurus>".normalize($thesaurus)."</keywordThesaurus>\n";
-        $kwElem .= "</keywordSet>\n";
-        $kwList .= $kwElem;
-    }
-    return $kwList;
+		foreach my $x (@$a_ref) {
+			my ( $kw, $kwType ) = @$x;
+			$kwElem .= "<keyword ";
+			if ( hasContent($kwType) && $kwType != "None" ) {
+				$kwElem .= "keywordType=\"" . lc($kwType) . "\"";
+			}
+			$kwElem .= ">$kw</keyword>\n";
+		}
+
+		$kwElem .=
+		    "<keywordThesaurus>"
+		  . normalize($thesaurus)
+		  . "</keywordThesaurus>\n";
+		$kwElem .= "</keywordSet>\n";
+		$kwList .= $kwElem;
+	}
+	return $kwList;
 }
 
 sub EMLStart() {
-    my $gmt = gmtime($now);
-    my $doc =  "<?xml version=\"1.0\" encoding=\"ISO-8859-1\"?>\n";
+	my $gmt = gmtime($now);
+	my $doc = "<?xml version=\"1.0\" encoding=\"ISO-8859-1\"?>\n";
 
-    $doc .= qq|<eml:eml
+	$doc .= qq|<eml:eml
       packageId="docid" system="knb"
       xmlns:eml="eml://ecoinformatics.org/eml-2.1.0"
       xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance"
